Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 3747)
@@ -1,5 +1,4 @@
 // Module PI : Peida Interactive     PIGraphicQuartz
-// Trace graphiques- Implementation X11  R. Ansari  97
-// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/IRFU (Saclay) / CEA
 
 #include <stdio.h>
@@ -8,14 +7,11 @@
 #include "sopnamsp.h"
 #include "pigraphquartz.h"
-
 
 /*  Variables globales pour modifier les GC  */
 #define NMAXCOL  32
 static  PIQuartzColor colpix[NMAXCOL];
-
-/*  GC pour DrawPixmap   
-    static GC dpxgc;   Pas utile ?? - Reza 02/05/2002 */
-
-// #define DEBUG_PIBWDGX     Flag pour impression de debug etc ...
+static const EventTypeSpec  gqHIViewSpec[] = {kEventClassControl,kEventControlDraw };
+
+OSStatus MyDrawEventHandler (EventHandlerCallRef myHandler,EventRef event, void *userData);
 
 /* --Methode-- */
@@ -23,5 +19,26 @@
 : PIGraphicGen(wdg)
 {
-
+	OSStatus err;
+	HIViewRef rootView;
+    HIRect      bounds;
+		
+	rootView = wdg->GetHIViewRef();
+	err = HIViewFindByID(rootView, kHIViewWindowContentID,&hiViewRef);
+	HIViewGetBounds (rootView, &bounds);
+	
+	printf("View Bounds (%g %g) [%g %g] \n",bounds.origin.x,bounds.origin.y,
+											bounds.size.width,bounds.size.height);
+
+	err = InstallEventHandler (GetControlEventTarget (hiViewRef),
+                            NewEventHandlerUPP (MyDrawEventHandler),
+                            GetEventTypeCount (gqHIViewSpec),
+                            (const EventTypeSpec*)&gqHIViewSpec,
+                            (void *) cgContext,
+                            NULL);
+	cgWindow =  HIViewGetWindow(rootView);
+	ShowWindow(cgWindow);
+	SetPortWindowPort(cgWindow);
+	QDBeginCGContext (GetWindowPort (cgWindow), &cgContext);
+	CGContextFlush(cgContext);
 }
 
@@ -37,4 +54,5 @@
 PIGraphicQuartz::~PIGraphicQuartz()
 {
+	QDEndCGContext (GetWindowPort(cgWindow), &cgContext);
 }
 
@@ -56,5 +74,14 @@
 void PIGraphicQuartz::Erase(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
 {
-return;
+	CGPoint pt;
+	CGSize sz;
+	CGRect cgRect;
+	pt.x = x0; 	pt.y = y0;
+	sz.width = (int)dx ; sz.height = (int)dy ;
+	cgRect.origin = pt;
+	cgRect.size = sz;
+	CGContextClearRect(cgContext, cgRect);
+	CGContextFlush(cgContext);
+	return;
 }
 
@@ -62,18 +89,40 @@
 void PIGraphicQuartz::DrawString(PIGrCoord x, PIGrCoord y, const char* s, unsigned long pos)
 {
-int dx, dy, xi, yi;
-xi = x;  yi = y;
-bool fgcsps = CalcStringPositionShift(s, pos, dx, dy);
-unsigned long txtdir = pos&PI_TextDirection;
-if (txtdir == PI_TextDirectionHorizontal) {
-  if (fgcsps) { xi -= dx;  yi -= dy; }
+	CGPoint cgPt;
+	int dx, dy, xi, yi;
+	float xpos, ypos;
+	xi = x;  yi = y;
+	xpos = x; ypos = y;
+	bool fgcsps = CalcStringPositionShift(s, pos, dx, dy);
+	unsigned long txtdir = pos&PI_TextDirection;
+	if (txtdir == PI_TextDirectionHorizontal) 
+	{
+	if (fgcsps) { xi -= dx;  yi -= dy; }
 //  XDrawString (mDisp, mWId, DefGC(), xi, yi, s, strlen(s));
-}
-else { 
-  if (txtdir == PI_TextDirectionVerticalDown) { xi += dy; yi -= dx; }
-  else {   xi -= dy; yi += dx; }
+	}
+	else 
+	{ 
+		if (txtdir == PI_TextDirectionVerticalDown) 
+		{ xi += dy; yi -= dx; }
+		else 
+		{ xi -= dy; yi += dx; }
   //DrawVerticalString(xi, yi, s, txtdir, false);
-}
-return;
+	}
+
+    CGAffineTransform myTextTransform;
+	CGContextSelectFont(cgContext, "Times-Bold", 10.0, kCGEncodingMacRoman);
+	CGContextSetCharacterSpacing (cgContext, 2);
+	CGContextSetTextDrawingMode (cgContext, kCGTextFill);
+
+    CGContextSetRGBFillColor (cgContext, 0, 1, 0, .5);// 6
+    CGContextSetRGBStrokeColor (cgContext, 0, 0, 1, 1);//
+	myTextTransform =  CGAffineTransformMakeRotation  (0.);// 8
+    CGContextSetTextMatrix (cgContext, myTextTransform);
+
+	CGContextShowTextAtPoint (cgContext, xpos, ypos, s, strlen(s));
+	cgPt = CGContextGetTextPosition (cgContext);
+	CGContextFlush(cgContext);
+
+	return;
 }
 
@@ -101,6 +150,17 @@
 void PIGraphicQuartz::DrawLine(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2)
 {
-// XDrawLine(mDisp, mWId, DefGC(), (int)x1, (int)y1, (int)x2, (int)y2);
-return;
+	float xf, yf;
+
+	CGContextBeginPath(cgContext);
+	xf = x1; yf = y1;
+	CGContextMoveToPoint (cgContext, xf, yf);
+	xf = x2; yf = y2;	
+	CGContextAddLineToPoint (cgContext, xf, yf);
+	CGContextSetLineWidth (cgContext, 2);
+	CGContextStrokePath (cgContext);
+	CGContextClosePath (cgContext);
+	CGContextFlush(cgContext);
+
+	return;
 }
 
@@ -109,15 +169,14 @@
 void PIGraphicQuartz::DrawBox(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
 {
-int ix0 = x0;
-int iy0 = y0;
-int idx = dx;
-int idy = dy;
-if (idx < 0)  { ix0 += idx;  idx = -idx; }
-if (idy < 0)  { iy0 += idy;  idy = -idy; }
-/*
-XDrawRectangle(mDisp, mWId, 
-               DefGC(), ix0, iy0, idx, idy);
-			   */
-return;
+	int ix0 = x0;
+	int iy0 = y0;
+	int idx = dx;
+	int idy = dy;
+	if (idx < 0)  { ix0 += idx;  idx = -idx; }
+	if (idy < 0)  { iy0 += idy;  idy = -idy; }
+	CGContextAddRect (cgContext, CGRectMake (ix0, iy0, idx, idy));
+	CGContextFlush(cgContext);
+
+	return;
 }
 
@@ -125,15 +184,14 @@
 void PIGraphicQuartz::DrawFBox(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
 {
-int ix0 = x0;
-int iy0 = y0;
-int idx = dx;
-int idy = dy;
-if (idx < 0)  { ix0 += idx;  idx = -idx; }
-if (idy < 0)  { iy0 += idy;  idy = -idy; }
-/*
-XFillRectangle(mDisp, mWId, 
-               DefGC(), ix0, iy0, idx, idy);
-			   */
-return;
+	int ix0 = x0;
+	int iy0 = y0;
+	int idx = dx;
+	int idy = dy;
+	if (idx < 0)  { ix0 += idx;  idx = -idx; }
+	if (idy < 0)  { iy0 += idy;  idy = -idy; }
+	CGContextFillRect (cgContext, CGRectMake (ix0, iy0, idx, idy));
+	CGContextFlush(cgContext);
+
+	return;
 }
 
@@ -141,9 +199,6 @@
 void PIGraphicQuartz::DrawCircle(PIGrCoord x0, PIGrCoord y0, PIGrCoord r)
 {
-/*
-XDrawArc(mDisp, mWId, DefGC(),
-         (int)x0-(int)r, (int)y0-(int)r, 2*(int)r, 2*(int)r, 0, 360*64);
-		 */
-return;
+	DrawArc(x0, y0, r, r, 0, 360);
+	return;
 }
 
@@ -151,9 +206,6 @@
 void PIGraphicQuartz::DrawFCircle(PIGrCoord x0, PIGrCoord y0, PIGrCoord r)
 {
-/*
-XFillArc(mDisp, mWId, DefGC(),
-         (int)x0-(int)r, (int)y0-(int)r, 2*(int)r, 2*(int)r, 0, 360*64);
-		 */
-return;
+	DrawFArc(x0, y0, r, r, 0, 360);
+	return;
 }
 
@@ -184,19 +236,23 @@
 void PIGraphicQuartz::DrawPolygon(PIGrCoord *x, PIGrCoord *y, int n, bool cinc)
 {
-/*
-XPoint multipoint[NMXXPOINTS];
-XPoint *pxp;
-int i;
-
-if (n <= 0)  return;
-if (n > NMXXPOINTS)  pxp = new XPoint[n];
-else pxp = multipoint;
-for(i=0; i<n; i++)  { pxp[i].x = x[i];  pxp[i].y = y[i]; } 
-int mode = CoordModeOrigin;
-if (cinc) mode =  CoordModePrevious;
-XDrawLines(mDisp, mWId, DefGC(), pxp, n, mode);
-if (n > NMXXPOINTS)  delete[] pxp;
-*/
-return;
+	int i;
+	CGPoint* points;
+
+	if (n <= 0)  return;
+	points = new CGPoint[n];
+	for (i = 0; i < n ; i++)
+	{
+		points[i].x = x[i];
+		points[i].y = y[i];
+	}
+	CGContextBeginPath (cgContext);
+	CGContextAddLines(cgContext, points, n);
+	
+	CGContextClosePath(cgContext);
+	CGContextStrokePath(cgContext);
+	CGContextFlush(cgContext);
+
+	delete[] points;
+	return;
 }
 
@@ -205,20 +261,23 @@
 void PIGraphicQuartz::DrawFPolygon(PIGrCoord *x, PIGrCoord *y, int n, bool cinc)
 {
-/*
-XPoint multipoint[NMXXPOINTS];
-XPoint *pxp;
-int i;
-
-if (n <= 0)  return;
-if (n > NMXXPOINTS)  pxp = new XPoint[n];
-else pxp = multipoint;
-for(i=0; i<n; i++)  { pxp[i].x = x[i];  pxp[i].y = y[i]; } 
-int mode = CoordModeOrigin;
-if (cinc) mode =  CoordModePrevious;
-XFillPolygon(mDisp, mWId, DefGC(), pxp, n, 
-                        Complex, mode);
-if (n > NMXXPOINTS)  delete[] pxp;
-*/
-return;
+	int i;
+	CGPoint* points;
+
+	if (n <= 0)  return;
+	points = new CGPoint[n];
+	for (i = 0; i < n ; i++)
+	{
+		points[i].x = x[i];
+		points[i].y = y[i];
+	}
+	CGContextBeginPath (cgContext);
+	CGContextAddLines(cgContext, points, n);
+	
+	CGContextClosePath(cgContext);
+	CGContextFillPath(cgContext);
+	CGContextFlush(cgContext);
+
+	delete[] points;
+	return;
 }
 
@@ -228,11 +287,21 @@
                          double degdeb, double deltadeg)
 {
-// Convention X est ds le sens trigo inverse
-degdeb = 360. - (degdeb+deltadeg);
-/*
-XDrawArc(mDisp, mWId, DefGC(),
-         (int)x0-(int)dx, (int)y0-(int)dy, (int)dx*2, (int)dy*2, (int)(degdeb*64.), (int)(deltadeg*64.));
-		 */
-return;
+	float xd, yd, xf, yf, radius, startAngle, endAngle;
+	xd = (int)x0;
+	yd = (int)y0;
+	xf = (int)x0 + (int)dx;
+	yf = (int)y0 + (int)dy;
+	radius = sqrtf((int)dx*(int)dx + (int)dy*(int)dy);
+	startAngle = 2 * 3.14 * degdeb / (360.);
+	endAngle = startAngle + 2 * 3.14 * deltadeg / (360.);
+
+	CGContextMoveToPoint (cgContext, xd, yd);
+	CGContextBeginPath(cgContext);
+	CGContextAddArc (cgContext, xf, yf, radius, startAngle, endAngle, 0);
+	CGContextStrokePath(cgContext);
+	CGContextClosePath(cgContext);
+	CGContextFlush(cgContext);
+
+	return;
 }
 
@@ -241,14 +310,24 @@
                          double degdeb, double deltadeg)
 {
-degdeb = 360. - (degdeb+deltadeg);
-/*
-XFillArc(mDisp, mWId, DefGC(),
-         (int)x0-(int)dx, (int)y0-(int)dy, (int)dx*2, (int)dy*2, (int)(degdeb*64.), (int)(deltadeg*64.));
-		 */
-return;
+	float xd, yd, xf, yf, radius, startAngle, endAngle;
+	xd = (int)x0;
+	yd = (int)y0;
+	xf = (int)x0 + (int)dx;
+	yf = (int)y0 + (int)dy;
+	radius = sqrtf((int)dx*(int)dx + (int)dy*(int)dy);
+	startAngle = 2 * 3.14 * degdeb / (360.);
+	endAngle = startAngle + 2 * 3.14 * deltadeg / (360.);
+
+	CGContextBeginPath(cgContext);
+	CGContextMoveToPoint (cgContext, xd, yd);
+	CGContextAddArc (cgContext, xf, yf, radius, startAngle, endAngle, 0);
+	CGContextClosePath(cgContext);
+	CGContextFillPath(cgContext);
+	CGContextFlush(cgContext);
+	return;
 }
 
 // Coordonnees pour tracer une etoile a 5 branches 
-static float starcoordx[10], starcoordy[10];
+// static float starcoordx[10], starcoordy[10];
 
 /* --Methode-- */
@@ -331,7 +410,8 @@
 void PIGraphicQuartz::DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n)
 {
+/*
 int i;
 if (n <= 0)  return;
-/*
+
 if (mMrk == PI_DotMarker)
   {
@@ -512,10 +592,31 @@
 void PIGraphicQuartz::SelForeground(PIColors col)
 {
-if (myLockFCol)  return;
-if (col == mFCol)  return;
-if ( (col < 0) || (col >= NMAXCOL))  return;
-// XSetForeground(mDisp, DefGC(), colpix[col]); 
-mFCol = col;  
-return;
+	if (myLockFCol)  return;
+	if (col == mFCol)  return;
+	if ( (col < 0) || (col >= NMAXCOL))  return;
+	// XSetForeground(mDisp, DefGC(), colpix[col]);
+	if (col == PI_Green)
+	{
+		CGContextSetRGBFillColor (cgContext, 0, 1, 0, 1);
+		CGContextSetRGBStrokeColor (cgContext, 0, 1, 0, 1);
+	}
+	else if (col == PI_Blue)
+	{
+		CGContextSetRGBFillColor (cgContext, 0, 0, 1, 1);	
+		CGContextSetRGBStrokeColor (cgContext, 0, 0, 1, 1);
+	}
+	else if (col == PI_Red)
+	{
+		CGContextSetRGBFillColor (cgContext, 1, 0, 0, 1);	
+		CGContextSetRGBStrokeColor (cgContext, 1, 0, 0, 1);
+	}
+	else
+	{
+		CGContextSetRGBFillColor (cgContext, 0, 0, 0, 1);	
+		CGContextSetRGBStrokeColor (cgContext, 0, 0, 0, 1);
+	}
+
+	mFCol = col;  
+	return;
 }
 
@@ -683,12 +784,18 @@
 void PIGraphicQuartz::SetClipRectangle(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
 {
-/*
-XRectangle xr;
-xr.x = x0;  xr.y = y0;
-xr.width = dx;  xr.height = dy;
-XSetClipRectangles(mDisp, DefGC(), 0, 0, &xr, 1, Unsorted);
-XSetClipRectangles(mDisp, mMrkGC, 0, 0, &xr, 1, Unsorted);
-*/
-return;
+	CGPoint pt;
+	CGSize sz;
+	CGRect cgRect;
+	pt.x = x0; 	pt.y = y0;
+	sz.width = (int)dx ; sz.height = (int)dy ;
+	cgRect.origin = pt;
+	cgRect.size = sz;
+	CGContextBeginPath(cgContext);
+	CGContextAddRect(cgContext, cgRect);
+
+	CGContextClosePath (cgContext);
+	CGContextClip(cgContext);
+	CGContextFlush(cgContext);	
+	return;
 }
 
@@ -791,7 +898,16 @@
 
 
-static bool fggrcx = false ;  // Flag init done
-
-
-
-
+/* Methode Generale */
+OSStatus MyDrawEventHandler (EventHandlerCallRef myHandler, EventRef event, void *userData)
+{
+	OSStatus status = noErr;
+ 
+    status = GetEventParameter (event, // 1
+                            kEventParamCGContextRef,
+                            typeCGContextRef,
+                            NULL,
+                            sizeof (CGContextRef),
+                            NULL,
+                            &userData);
+    return status;
+}
Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.h	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.h	(revision 3747)
@@ -113,4 +113,7 @@
   PIQuartzColor mFCfMap, mBCfMap;
   PIQuartzColor sFCfMap, sBCfMap;
+  HIViewRef hiViewRef;
+  CGContextRef cgContext;
+  WindowRef cgWindow;
 };
 
Index: /trunk/SophyaPI/PI/Quartz/pioptmenuquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pioptmenuquartz.cpp	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/pioptmenuquartz.cpp	(revision 3747)
@@ -0,0 +1,71 @@
+/*
+ *  pioptmenuquartz.cpp
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 19/09/08.
+ *  Copyright 2008 __MyCompanyName__. All rights reserved.
+ *
+ */
+
+#include "pioptmenuquartz.h"
+
+
+PIOptMenuQuartz::PIOptMenuQuartz(PIContainer* par, const char* nom, int sx, int sy, int px, int py)
+: PIOptMenuGen(par, nom, sx, sy, px, py)
+{
+	SetRect(&wdgRect,px,py,px+sx,py+sy);
+	wPtr = par->GetWindowRef();
+}
+
+PIOptMenuQuartz::~PIOptMenuQuartz()
+{
+}
+
+
+/* --Methode-- */
+void PIOptMenuQuartz::FinishCreate()
+{
+	return;
+}
+
+
+/* --Methode-- */
+void PIOptMenuQuartz::AppendPDMenu(PIMenu* pdm)
+{
+	OSStatus status ;
+	ControlRef contH = GetHIViewRef();
+	status = CreatePopupButtonControl (wPtr,&wdgRect,title,pdm->GetMenuID(),true,0,teFlushDefault,normal,&contH);
+	SetControlTitleWithCFString (contH, title);
+	return;
+}
+
+/* --Methode-- */
+void PIOptMenuQuartz::Process(PIMessage msg, PIMsgHandler* sender, void* data)
+{
+	printf("Process Pop : %d \n",msg);
+	SetValue(UserMsg(msg));
+	ReSend(msg, this, NULL);
+	return;
+}
+
+/* --Methode-- */
+void PIOptMenuQuartz::SetLabel(const string & s)
+{
+	return;
+}
+
+
+/* --Methode-- */
+void PIOptMenuQuartz::SetValueStr(string & s)
+{
+	return;
+}
+
+
+/* --Methode-- */
+void PIOptMenuQuartz::SetValue(PIMessage msg)
+{
+	return;
+}
+
+
Index: /trunk/SophyaPI/PI/Quartz/pioptmenuquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pioptmenuquartz.h	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/pioptmenuquartz.h	(revision 3747)
@@ -0,0 +1,55 @@
+/*
+ *  pioptmenuquartz.h
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 19/09/08.
+ *
+ */
+#ifndef PIOPTMENUQUARTZ_H_SEEN
+#define PIOPTMENUQUARTZ_H_SEEN
+
+
+#include <Carbon/Carbon.h>
+#include "pisysdep.h"
+#include PIMENU_H
+#include PICONT_H
+#include <pioptmenugen.h>
+
+class PIOptMenuQuartz : public PIOptMenuGen {
+public:
+	            PIOptMenuQuartz(PIContainer* par, const char* nom, int sx=50, int sy=15, int px=0, int py=0);
+	            ~PIOptMenuQuartz();
+
+  virtual void	    FinishCreate(); 
+
+  virtual void      AppendPDMenu(PIMenu* pdm);
+
+  virtual void      Process(PIMessage msg, PIMsgHandler* sender, void* data=NULL);
+				   
+  virtual string    GetValueStr() { return(mStext); }
+  virtual PIMessage GetValue()    { return(mSmsg); } 
+  virtual void      SetValueStr(string & s);
+  virtual void      SetValue(PIMessage msg);
+
+
+//  Pour utilisation privee dans call-back, .... 
+  virtual void       SetLabel(string const&);
+//  inline  GC        myGC() {if (mgc == 0) createmygc();  return(mgc); }  
+
+protected:
+  string   mStext;
+  PIMessage mSmsg;
+  list<PIMenu*> mPDMList;
+  WindowPtr wPtr;
+  ControlActionUPP _actionProc;
+
+//  SysDWdg mLabel;
+//  GC mgc;
+//  void              createmygc();
+};
+
+
+typedef PIOptMenuQuartz  PIOptMenu ;
+
+
+#endif
Index: /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp	(revision 3747)
@@ -0,0 +1,356 @@
+/*
+ *  pistdwdgmosx.cpp
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 24/08/07.
+ *  Copyright 2007 __MyCompanyName__. All rights reserved.
+ *
+ */
+
+#include "pistdwdgquartz.h"
+
+vector<PIWdg*> vpiwdg;
+
+static void CommonControlActionCallback (ControlRef theControl, ControlPartCode partCode);
+
+static void CommonControlActionCallback (ControlRef theControl, ControlPartCode partCode)
+{
+	vector<PIWdg*>::iterator it;
+	for(it = vpiwdg.begin(); it != vpiwdg.end(); it++)
+        {
+			printf ("click : %d \n",(int)(*it)->Msg());
+            if (((*it)->GetHIViewRef()) == theControl)
+            {
+				printf ("Valid : %d \n",(int)(*it)->Msg());
+				(*it)->Send((*it)->Msg(), PIMsg_Click, NULL);
+                break;
+            }
+        }
+	return;
+}
+
+/* ========== PILabelQuartz ========== */
+
+/* --Methode-- */
+PILabelQuartz::PILabelQuartz(PIContainerGen *par, const char *nom, int sx, int sy, int px, int py)
+: PILabelGen(par, nom, sx, sy, px, py)
+{
+	OSStatus err;
+	WindowRef wParent;
+	
+	string sNom(nom);
+	wParent = ((PIContainer *)par)->GetWindowRef();
+	SetPortWindowPort(wParent);
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+	cfsrLabel = CFStringCreateWithCString(kCFAllocatorDefault,nom,kCFStringEncodingMacRoman);
+	err = CreateStaticTextControl (wParent, &wdgRect, cfsrLabel, NULL, &viewH);
+}
+
+/* --Methode-- */
+PILabelQuartz::~PILabelQuartz()
+{
+}
+
+/* --Methode-- */
+void PILabelQuartz::SetLabel(string const& sLabel)
+{
+	OSStatus err;
+	
+	cfsrLabel = CFStringCreateWithCString(kCFAllocatorDefault,sLabel.c_str(),kCFStringEncodingMacRoman);
+	// SetPortWindowPort(wParent);
+
+	err = SetControlData (viewH,0,kControlEditTextCFStringTag,sizeof(cfsrLabel),(Ptr)&cfsrLabel);
+
+	return;
+}
+
+
+/* ========== PITextQuartz ========== */
+
+/* --Methode-- */
+PITextQuartz::PITextQuartz(PIContainerGen *par, const char *nom, int sx, int sy, int px, int py)
+: PITextGen(par, nom, sx, sy, px, py)
+{
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+}
+
+/* --Methode-- */
+PITextQuartz::PITextQuartz(PIContainerGen* par, const char* nom, bool vsb, bool hsb,
+         		     int sx, int sy, int px, int py)
+: PITextGen(par, nom, vsb, hsb, sx, sy, px, py)
+{
+}
+
+/* --Methode-- */
+PITextQuartz::~PITextQuartz()
+{
+}
+
+/* --Methode-- */
+void PITextQuartz::SetText(string const& s)
+{	
+	OSStatus err;
+	WindowRef wParent = ((PIContainer *)Parent())->GetWindowRef();
+
+	unicodeText = CFStringCreateWithCString (NULL,(char *)s.c_str(), kCFStringEncodingMacRoman);
+	err = CreateEditUnicodeTextControl (wParent,&wdgRect,unicodeText,false,NULL,&viewH);
+
+	return;
+}
+
+/* --Methode-- */
+string PITextQuartz::GetText() const
+{
+	CFStringRef str;
+	char* cText;
+
+	GetControlData(viewH, kControlEditTextPart, kControlEditTextCFStringTag, sizeof(str),&str,NULL);
+	
+	cText = (char *)CFStringGetCStringPtr(str,kCFStringEncodingMacRoman);	
+	string sText(cText);	
+	return (sText);
+}
+
+/* --Methode-- */
+void PITextQuartz::SetMutiLineMode(bool mlm)
+{
+	return;
+}
+
+
+/* --Methode-- */
+void PITextQuartz::SetTextEditable(bool te)
+{
+	if (te == false)
+		DeactivateControl (viewH);
+
+	return;
+}
+
+/* --Methode-- */
+void PITextQuartz::SetMsg(PIMessage msg)
+{
+}
+
+
+/* ========== PIHITextViewQuartz ========== */
+
+/* --Methode-- */
+PIHITextViewQuartz::PIHITextViewQuartz(PIContainerGen *par, const char *nom, int sx, int sy, int px, int py)
+: PITextGen(par, nom, sx, sy, px, py)
+{
+	OSStatus err;
+	HIRect	hiRect; // = { { 0, 0 }, { 100, 100 } };
+	int ox,oy,fx,fy;
+	int mx,my;
+	WindowRef wParent = ((PIContainer *)par)->GetWindowRef();
+	mx = sx/50;
+	my = sy/50; 
+	ox = px+mx;
+	oy = py+my;
+	fx = px+sx-mx;
+	fy = py+sy-my;
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+
+	SetRect(&userPaneRect,ox,oy,fx,fy);
+	hiRect.origin.x = ox;
+	hiRect.origin.y = oy;
+	hiRect.size.width = fx-ox;
+	hiRect.size.height = fy-oy;
+	err = HITextViewCreate (&hiRect,0,0,&outTextView);
+	err = CreateUserPaneControl (wParent, &userPaneRect,kControlSupportsEmbedding,&fUserPane);
+	err = SetControlVisibility(fUserPane, true, true );
+}
+
+/* --Methode-- */
+PIHITextViewQuartz::PIHITextViewQuartz(PIContainerGen* par, const char* nom, bool vsb, bool hsb,
+         		     int sx, int sy, int px, int py)
+: PITextGen(par, nom, vsb, hsb, sx, sy, px, py)
+{
+}
+
+/* --Methode-- */
+PIHITextViewQuartz::~PIHITextViewQuartz()
+{
+}
+
+
+/* --Methode-- */
+void PIHITextViewQuartz::SetText(string const& s)
+{	
+	OSStatus err;
+	CFStringRef cfsrText;
+	
+	cfsrText = CFStringCreateWithCString (NULL,(char *)s.c_str(), kCFStringEncodingMacRoman);
+
+	TXNObject txn = HITextViewGetTXNObject(outTextView);
+	textLength = CFStringGetLength(cfsrText);
+	uniChars = (UniChar*) malloc( sizeof( UniChar ) * textLength );
+	CFStringGetCharacters(cfsrText, CFRangeMake( 0, textLength ), uniChars );
+	err = TXNSetData(txn,kTXNUnicodeTextData, uniChars, textLength * sizeof( UniChar ), 0, 0 );
+	err = HIViewAddSubview (fUserPane, outTextView);
+	HIViewPlaceInSuperviewAt (outTextView,10,10);
+	ShowControl (fUserPane);
+	err = HIViewSetVisible (outTextView, true);
+
+	return;
+}
+
+/* --Methode-- */
+string PIHITextViewQuartz::GetText() const
+{
+	CFStringRef str;
+	char* cText;
+
+	GetControlData(outTextView, kControlEditTextPart, kControlEditTextCFStringTag, sizeof(str),&str,NULL);
+	cText = (char *)CFStringGetCStringPtr(str,kCFStringEncodingMacRoman);
+	/*
+	textLength = CFStringGetLength(str);
+	uniChars = (UniChar*) realloc( sizeof( UniChar ) * textLength );
+	CFStringGetCharacters(str, CFRangeMake( 0, textLength ), uniChars );
+	*/
+	
+	string sText(cText);	
+	return (sText);
+}
+
+
+/* --Methode-- */
+void PIHITextViewQuartz::SetMutiLineMode(bool mlm)
+{
+	return;
+}
+
+
+/* --Methode-- */
+void PIHITextViewQuartz::SetTextEditable(bool te)
+{
+	return;
+}
+
+
+/* --Methode-- */
+void PIHITextViewQuartz::SetMsg(PIMessage msg)
+{
+
+}
+
+/* ========== PIButtonQuartz ========== */
+
+EventTypeSpec controlEvents[] = {{kEventClassControl, kEventControlHit}};
+
+PIButtonQuartz::PIButtonQuartz(PIContainerQuartz *par,const char *nom, PIMessage msg,int sx, int sy, int px, int py)
+:PIButtonGen(par,nom,msg,sx,sy,px,py)
+{
+	WindowRef wParent = ((PIContainer *)par)->GetWindowRef();
+	SetPortWindowPort(wParent);
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+
+    CreatePushButtonControl (par->GetWindowRef(),&wdgRect,title,&viewH);
+    SetControlTitleWithCFString (viewH, title);
+	_actionProc = NewControlActionUPP (CommonControlActionCallback);
+	SetControlAction (viewH, _actionProc);
+	vpiwdg.push_back(this);
+}
+
+
+PIButtonQuartz::~PIButtonQuartz()
+{
+}
+
+void PIButtonQuartz::ActivatePress(bool acp)
+{
+	return;
+}	
+
+void PIButtonQuartz::SetLabel(string const& sText)
+{
+    title = CFStringCreateWithCString (NULL, sText.c_str(), kCFStringEncodingMacRoman);
+	SetControlTitleWithCFString(viewH,title);
+	return;
+}
+
+
+
+/* ========== PICheckBoxQuartz ========== */
+
+PICheckBoxQuartz::PICheckBoxQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg, int sx, int sy, int px, int py)
+:PICheckBoxGen(par,nom,msg,sx,sy,px,py)
+{
+	WindowRef wParent = ((PIContainer *)par)->GetWindowRef();
+	SetPortWindowPort(wParent);
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+    CreateCheckBoxControl (par->GetWindowRef(),&wdgRect,title,0,TRUE,&viewH);
+    SetControlTitleWithCFString (viewH, title);
+	_actionProc = NewControlActionUPP (CommonControlActionCallback);
+	SetControlAction (viewH, _actionProc);
+	_state = GetControl32BitValue (viewH);
+
+	vpiwdg.push_back(this);
+}
+
+
+PICheckBoxQuartz::~PICheckBoxQuartz()
+{
+}
+
+void PICheckBoxQuartz::SetState(bool acp)
+{
+	_state = acp;
+	return;
+}
+
+bool PICheckBoxQuartz::GetState()
+{
+	_state = GetControl32BitValue (viewH);
+	printf("GetState : %d ",_state);
+	return _state;
+}
+
+/* ========== PIRadioQuartz ========== */
+
+PIRadioQuartz::PIRadioQuartz(PIContainerQuartz *par,const char *nom, PIMessage msg,int sx, int sy, int px, int py,
+							int initialValue)
+:PIWdg(par,nom,sx,sy,px,py)
+{
+	SetMsg(msg);
+	WindowRef wParent = ((PIContainer *)par)->GetWindowRef();
+	SetPortWindowPort(wParent);
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+    CreateRadioButtonControl (par->GetWindowRef(),&wdgRect,title,initialValue,FALSE,&viewH);
+    SetControlTitleWithCFString (viewH, title);
+	_actionProc = NewControlActionUPP (CommonControlActionCallback);
+	SetControlAction (viewH, _actionProc);
+	vpiwdg.push_back(this);
+}
+
+PIRadioQuartz::~PIRadioQuartz()
+{
+}
+
+/* ========== PIRadioGroupQuartz ========== */
+
+PIRadioGroupQuartz::PIRadioGroupQuartz(PIContainerQuartz *par,const char *nom, PIMessage msg,int sx, int sy, int px, int py)
+:PIWdg(par,nom,sx,sy,px,py)
+{
+	SetMsg(msg);
+	WindowRef wParent = ((PIContainer *)par)->GetWindowRef();
+	SetPortWindowPort(wParent);
+    SetRect(&wdgRect,px,py,px+sx,py+sy);
+    OSErr error;
+	error = CreateRadioGroupControl (par->GetWindowRef(),&wdgRect,&viewH);
+	_state = 0;
+}
+
+void PIRadioGroupQuartz::AddRadioButton(PIRadio* piRadio)
+{
+	OSErr error;
+	error = EmbedControl(piRadio->GetHIViewRef(),viewH);
+		
+	return;
+}
+
+PIRadioGroupQuartz::~PIRadioGroupQuartz()
+{
+}
+
Index: /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.h	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.h	(revision 3747)
@@ -0,0 +1,132 @@
+#ifndef PISTDWDGMOSX_H_SEEN
+#define PISTDWDGMOSX_H_SEEN
+
+#include "piwdgquartz.h"
+#include "pistdwdggen.h"
+#include "PIContainerQuartz.h"
+
+class PILabelQuartz : public PILabelGen
+{
+public:
+	PILabelQuartz(PIContainerGen* par, const char* nom,int sx=10, int sy=10, int px=0, int py=0);
+	
+	~PILabelQuartz();
+	
+	virtual void SetLabel(string const& sLabel);
+	
+protected:
+	CFStringRef cfsrLabel;
+	ControlRef contH;
+};
+
+class PITextQuartz : public PITextGen
+{
+public:
+	PITextQuartz(PIContainerGen *par, const char *nom, 
+				int sx=10, int sy=10, int px=0, int py=0);
+
+	PITextQuartz(PIContainerGen* par, const char* nom, bool vsb, bool hsb,
+         		     int sx=100, int sy=100, int px=0, int py=0);
+  virtual           ~PITextQuartz();
+  virtual void      SetText(string const&);
+  virtual string    GetText() const;
+
+  virtual void      SetMutiLineMode(bool mlm=false);
+  virtual void      SetTextEditable(bool te=true);
+
+  virtual void		SetMsg(PIMessage msg=0);
+  	
+protected:
+	CFStringRef unicodeText;
+	ControlRef contH;
+};
+
+
+class PIHITextViewQuartz : public PITextGen
+{
+public:
+	PIHITextViewQuartz(PIContainerGen *par, const char *nom, 
+				int sx=10, int sy=10, int px=0, int py=0);
+
+	PIHITextViewQuartz(PIContainerGen* par, const char* nom, bool vsb, bool hsb,
+         		     int sx=100, int sy=100, int px=0, int py=0);
+  virtual           ~PIHITextViewQuartz();
+  virtual void      SetText(string const&);
+  virtual string    GetText() const;
+
+  virtual void      SetMutiLineMode(bool mlm=false);
+  virtual void      SetTextEditable(bool te=true);
+
+  virtual void		SetMsg(PIMessage msg=0);
+  	
+protected:
+	UniChar* uniChars;
+	CFIndex textLength;
+	HIViewRef outTextView;
+	HIRect hiRect;
+	ControlRef fUserPane;
+	Rect userPaneRect;
+};
+
+class PIButtonQuartz : public PIButtonGen
+{
+public:
+    PIButtonQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg = PIMsg_Click, 
+					int sx=10, int sy=10, int px=0, int py=0);
+    virtual	~PIButtonQuartz();
+	virtual void       ActivatePress(bool acp=false);
+	virtual void       SetLabel(string const&);
+
+private:
+	ControlActionUPP _actionProc;
+};
+
+class PICheckBoxQuartz : public PICheckBoxGen
+{
+public:
+    PICheckBoxQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg = PIMsg_Click, 
+					int sx=10, int sy=10, int px=0, int py=0);
+    virtual	~PICheckBoxQuartz();
+	virtual void	SetState(bool acp=false);
+	virtual bool	GetState();
+
+private:
+	ControlActionUPP _actionProc;
+	int _state;
+};
+
+class PIRadioQuartz : public PIWdg
+{
+public:
+    PIRadioQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg = PIMsg_Click, 
+					int sx=10, int sy=10, int px=0, int py=0, int initialValue =0);
+    virtual	~PIRadioQuartz();
+
+private:
+	ControlActionUPP _actionProc;
+	int _state;
+};
+
+class PIRadioGroupQuartz : public PIWdg
+{
+public:
+    PIRadioGroupQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg = PIMsg_Click, 
+					int sx=10, int sy=10, int px=0, int py=0);
+    virtual	~PIRadioGroupQuartz();
+	void AddRadioButton(PIRadioQuartz* piRadio);
+
+private:
+	int _state;
+};
+
+// INTERFACES
+
+typedef PIRadioGroupQuartz PIRadioGroup;
+typedef PIRadioQuartz PIRadio;
+typedef PICheckBoxQuartz PICheckBox;
+typedef PIButtonQuartz PIButton;
+typedef PILabelQuartz PILabel;
+typedef PITextQuartz PIText;
+typedef PIHITextViewQuartz PITextView;
+
+#endif
